﻿/**
* SimpleMemo v0.0.0 / ScriptUI
* Kareobana(http://atarabi.com/)
*
* dependencies :
*     KIKAKU.UIBuilder 1.0.0
*/

(function (global) {
  new KIKAKU.UIBuilder(global, 'SimpleMemo', {version: '0.0.0', author: 'Kareobana', url: 'http://atarabi.com/', width: 250})
  .add('hidden', 'Titles', [])
  .add('hidden', 'Refresh', function () {
    var title = this.get('Title');
    if (title !== null) {
      try {
        var text = this.getFile(title);
        this.set('Memo', text);
      } catch (e) {
        alert(e);
      }
    }
  })
  .add('textarea', 'Memo', '', {
    title: false,
    height: 150,
    callback: function () {
      var title = this.get('Title');
      if (title !== null) {
        var memo = this.get('Memo');
        try {
          this.saveFile(title, memo);
        } catch (e) {
          alert(e);
        }
      }
    }
  })
  .add('popup', 'Title', undefined, function () {
    var title = this.get('Title');
    if (title !== null) {
      try {
        var memo = this.getFile(title);
        this.set('Memo', memo);
      } catch (e) {
        alert(e);
      }
    }
  })
  .add('script', 'Add', function () {
    var title = prompt('Input a title', '');
    if (title === null || title === '') {
      return;
    }

    var titles = this.get('Titles');
    for (var i = 0, l = titles.length; i < l; i++) {
      if (title === titles[i]) {
        alert(title + ' has exists');
        return;
      }
    }

    try {
      if (titles.length === 0) {
        this.saveFile(title, this.get('Memo'));
      } else {
        this.saveFile(title, '');
      }
      titles.push(title);
      this.replaceItems('Title', titles);
      this.set('Title', title);
      this.execute('Refresh');
    } catch (e) {
      alert(e);
    }
  })
  .add('script', 'Remove', function () {
    var title = this.get('Title');
    if (title === null) {
      return;
    }

    var do_remove = confirm('Remove ' + title + '?');
    if (do_remove) {
      try {
        this.deleteFile(title);

        var titles = this.get('Titles');
        for (var i = 0, l = titles.length; i < l; i++) {
          if (title === titles[i]) {
            titles.splice(i, 1);
            break;
          }
        }
        this.replaceItems('Title', titles);
        this.execute('Refresh');
      } catch (e) {
        alert(e);
      }
    }
  })
  .build(function () {
    try {
      var titles = this.getFilenames();
      this.set('Titles', titles);
      this.replaceItems('Title', titles);
      this.execute('Refresh');
    } catch (e) {
      alert(e);
    }
  });

})(this);
